<?php
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . '/common.php';
include_once $path . '/Model_adm.php';
include_once $path . '/plugin/plan/Model_plan.php';
include_once $path . '/plugin/plan/Controller_plan.php';

$controller = new Controller_Plan($path, $dbconnection, $user);

// Check if user has map_view right
if(!$controller->isUserPerms['view'])
{
	$smarty->display('no_access.html');
	exit(0);
}
$smarty->assign('isUserPerms', $controller->isUserPerms);

if(isset($_GET['action']))
{
    $action = $_GET['action'];
}
elseif(isset($_POST['action']))
{
    $action = $_POST['action'];
}
else
{
    $action = 'show';
}
$smarty->assign('action', $action);

$cleanURI = false;
if(isset($_GET['delete_success']))
{
    if($_GET['delete_success'] == 'fold')
    {
        $smarty->assign('success_message', $lang['PLAN_FOLDER_DELETE_SUCCESS']);
    }
    elseif($_GET['delete_success'] == 'plan')
    {
        $smarty->assign('success_message', $lang['PLAN_DELETE_SUCCESS']);
    }
    $cleanURI = true;
}
if($controller->isUserPerms['admin'])
{
    //si on veut déplacer un dossier ou plan par drag & drop
    if($action == 'move')
    {
        $ajaxOutput = array('success' => false, 'message' => '');
        if(!empty($_POST['name']) && !empty($_POST['type']) && !empty($_POST['id']) && is_numeric($_POST['id']) && !empty($_POST['parent']) && is_numeric($_POST['parent']))
        {
            //on vérifie si l'user a accès en écriture sur l'élément a déplacé et celui de destination
            $parentAccess = $controller->checkUserFolderPrivilege($_POST['parent']);
            if($_POST['type'] == 'folder')
            {
                $itemAccess = $controller->checkUserFolderPrivilege($_POST['id']);
            }
            elseif($_POST['type'] == 'plan')
            {
                $itemAccess = $controller->checkUserPlanPrivilege($_POST['id']);
            }
            //si il a les accès creator ou write, on peut déplacer
            if($itemAccess['WRITE'] && $parentAccess['WRITE'])
            {
                try
                {
                    if($_POST['type'] == 'folder')
                    {
                        Model_Plan::updateFolder($dbconnection, $_POST['id'], $_POST['name'], $_POST['parent']);
                    }
                    elseif($_POST['type'] == 'plan')
                    {
                        Model_plan::movePlan($dbconnection, $_POST['id'], $_POST['parent']);
                    }
                    else
                    {
                        throw new EsiaDbException('ERROR: Wrong item type');
                    }
                    $ajaxOutput['success'] = true;
                    $ajaxOutput['message'] = strtoupper($_POST['name']) . $lang['PLAN_MOVE_SUCCESS'];
                }
                catch (EsiaDbException $e)
                {
                    $ajaxOutput['message'] = $e->getMessage();
                }
            }
            else
            {
                $accessError = '';
                if(!$itemAccess['WRITE'])
                {
                    $accessError = sprintf($lang['PLAN_MOVE_FAILED_ITEM_RIGHTS'], strtoupper($_POST['name']));
                }
                if(!$parentAccess['WRITE'])
                {
                    if(!empty($accessError))
                    {
                        $accessError .= "<br/>";
                    }
                    $accessError .= $lang['PLAN_MOVE_FAILED_TARGET_RIGHTS'];
                }
                $ajaxOutput['message'] = $accessError;
            }
        }
        else
        {
            $ajaxOutput['message'] = $lang['PLAN_FOLDER_UPDATE_FAILED'];
        }

        echo json_encode($ajaxOutput);
        exit(0);
    }
    //si on veut créer un répertoire ou un plan
    elseif($action == 'create')
    {
        $cleanURI = true;
        $parent = null;
        if(!empty($_POST['folder_id']) && is_numeric($_POST['folder_id']))
        {
            $parent = $_POST['folder_id'];
        }
        try
        {
            if(!empty($_POST['plan_name']) && !empty($_POST['plan_type']) && is_numeric($_POST['plan_type']))
            {
                    if(($_POST['plan_type'] == -1) && $controller->isUserPerms['create_folder'])
                    {
                        //création d'un répertoire
                        Model_Plan::addFolder($dbconnection, $_POST['plan_name'],$parent,$user->getId());
                        $smarty->assign('success_message',$lang['PLAN_FOLDER_CREATE_SUCCESS']);
                    }
                    elseif($controller->isUserPerms['create_plan'])
                    {
                        //création d'un plan
                        Model_plan::addPlan($dbconnection,$_POST['plan_name'],$_POST['plan_type'],null,null,$user->getId(),$parent);
                        $smarty->assign('success_message',$lang['PLAN_ADD_SUCCES']);
                    }
                    else
                    {
                        $smarty->assign('error_message',$lang['PLAN_ADD_FAILED'] . '<br/>' . $lang['PLAN_ADD_FAILED_USER_RIGHTS']);
                    }
            }
            else
            {
                $smarty->assign('error_message',$lang['PLAN_ADD_FAILED'] . '<br/>' . $lang['PLAN_ADD_FAILED_MISSING_VAR']);
            }
        }
        catch(EsiaDbException $e)
        {
            $smarty->assign('error_message', $e->getMessage());
        }
    }
    //si on veut mettre à jour un répertoire
    elseif($action == 'update')
    {
        $cleanURI = true;
        if(!empty($_POST['folder_name']) && !empty($_POST['folder_id']) && is_numeric($_POST['folder_id']))
        {
            try
            {
                $parent = null;
                //mise à jour du nom et parent du répertoire
                if(isset($_POST['folder_parent']))
                {
                    $parent = $_POST['folder_parent'];
                }
                Model_Plan::updateFolder($dbconnection, $_POST['folder_id'], $_POST['folder_name'], $parent);
                //mise à jour des privilèges d'accès au répertoire
                $currentUsersAccessRight = Model_Plan::getFolderUserAccess($dbconnection, $_POST['folder_id']);
				$newAccessUsersIds = $controller->setReadWritePrivilegeList($currentUsersAccessRight, $_POST['read_userplan'], $_POST['write_userplan']);
                //update privilèges
                Model_Plan::updateFolderPrivilege($dbconnection, $_POST['folder_id'], false, $newAccessUsersIds['READ'], $newAccessUsersIds['WRITE']);
                $smarty->assign('success_message', $lang['PLAN_FOLDER_UPDATE_SUCCESS']);
            }
            catch (EsiaDbException $e)
            {
                $smarty->assign('error_message', $e->getMessage());
            }
        }
        else
        {
            $smarty->assign('error_message', $lang['PLAN_FOLDER_UPDATE_FAILED']);
        }
    }
    //si on veut supprimer un répertoire
    elseif($action == 'delete' && $controller->isUserPerms['create_folder'])
    {
        if(!empty($_POST['content_action']) && !empty($_POST['folder_id']) && is_numeric($_POST['folder_id']))
        {
			$errorDel = "";
            try
            {
                $parent = null;
                if(!empty($_POST['folder_parent']))
                {
                    $parent = $_POST['folder_parent'];
                }
                $deleteContent = true;
                if($_POST['content_action'] != 'delete')
                {
                    $deleteContent = false;
                }
                Model_Plan::deleteFolder($dbconnection, $_POST['folder_id'], $deleteContent);

            }
            catch (EsiaDbException $e)
            {
				$errorDel = $e->getMessage();
                $smarty->assign('error_message', $errorDel);
            }

			if(empty($errorDel))
			{
				// revenir au dossier parent (si null = racine)
                $url = $controller->pluginURL . $controller::FOLDERS_CONTROLLER . "?";
                if(!empty($parent))
                {
                    $url .= "id=$parent&";
                }
                $url .= "delete_success=fold";

                ob_end_clean();
                header("Location: $url");
                exit(0);
			}
        }
        else
        {
            $smarty->assign('error_message', $lang['PLAN_FOLDER_DELETE_FAILED']);
        }
    }
}

$folderid = null;
$folderName = '';
$folderParent = null;
$access = '';
$folders = array();
if(!empty($_GET['id']) && is_numeric($_GET['id']))
{
    $folderid = $_GET['id'];
    $smarty->assign('folder_id', $folderid);
    $folders = Model_plan::getFolders($dbconnection, $folderid);
    $folderName = $folders[$folderid]['name'];
    $access = $controller->checkUserFolderPrivilege($folderid);
    $folderParent = $folders[$folderid]['parent'];
    $smarty->assign('folder_parent', $folderParent);
}
else
{
    $smarty->assign('folder_id',0);
    $folderName = $lang['PLAN_FOLDER_ROOT'];
}
$smarty->assign('folder_name', $folderName);

// NAVBAR
$controller->setNavBar($navbar, $lang['WEBP_PLAN'], $folders, $_GET['id'], null);

//variables utiles pour l'administration
if($controller->isUserPerms['admin'])
{
    //actions permises sur le dossier courant
    $folderActionsAuthorized = array(
        'update' => false,
        'delete' => false,
        'create_folder' => false,
        'create_plan' => false,
    );
    if(empty($folderid))
    {
        //autorise la creation sur le dossier racine
        $folderActionsAuthorized['create_folder'] = $controller->isUserPerms['create_folder'];
        $folderActionsAuthorized['create_plan'] = $controller->isUserPerms['create_plan'];
    }
    elseif($access['WRITE'])
    {
        $folderActionsAuthorized['update'] = true;
        $folderActionsAuthorized['delete'] = true;
        $folderActionsAuthorized['create_folder'] = $controller->isUserPerms['create_folder'];
        $folderActionsAuthorized['create_plan'] = $controller->isUserPerms['create_plan'];
    }
    $smarty->assign('authorized_actions', $folderActionsAuthorized);

    //récupère la liste des dossiers dont l'utilisateur a les droits write pour le déplacement
    $foldersList = $controller->getMoveFoldersList($lang['PLAN_FOLDER_ROOT'], $folderParent, $folderid);
    $smarty->assign('list_folders', $foldersList);

    $list_user = Model_adm::searchUser($dbconnection, null);
    $smarty->assign('list_user', $list_user);
    $userAccessRight = Model_Plan::getFolderUserAccess($dbconnection, $folderid);
    $smarty->assign('list_user_read_access', $userAccessRight['READ']);
    $smarty->assign('list_user_write_access', $userAccessRight['WRITE']);
    $planTypes = Model_plan::getPlanType($dbconnection);
    foreach ($planTypes as $key => $planType)
    {
        //utilisé pour trouver la variable de langue correspondante au texte du type de plan
        $planTypes[$key]["lang"] = "PLAN_TYPE_" . strtoupper($planType["name"]);
    }
	// sort plan types by type name
	usort($planTypes, function($a, $b) {
		return strcmp($a['name'], $b['name']);
	});
    $smarty->assign('plan_types', $planTypes);
    // modifications sur le texte contenu dans les variables de langues
    $langDeleteWarn = sprintf($lang['PLAN_FOLDER_DELETE_WARN'], strtoupper($folderName));
    $smarty->assign('lang_delete_warn', $langDeleteWarn);
}
//recupération des éléments a afficher dans le dossier
$plans = Model_plan::getPlan($dbconnection, null, $user->getId());
$folders = array();
$element = array();
$planinfolder = array();
foreach($plans as $plan)
{
        if(!empty($folderid))
        {
            if($plan['folders'] == $folderid)
            {
                $planinfolder[] = array('id'=>$plan['id'], 'name'=>$plan['name'], 'url'=>$controller->pluginURL . $plan['type_controller'] . '&id=' . $plan['id'], 'type'=>'plan');
            }
            elseif(!in_array($plan['folders'], $folders) && !empty($plan['folders']) )
            {
                $folders[] = $plan['folders'];
            }
        }
        else
        {
            if(empty($plan['folders']))
            {
                $planinfolder[] = array('id'=>$plan['id'], 'name'=>$plan['name'], 'url'=>$controller->pluginURL . $plan['type_controller'] . '&id=' . $plan['id'], 'type'=>'plan');
            }
            elseif(!in_array($plan['folders'], $folders))
            {
                $folders[] = $plan['folders'];
            }
        }
}
$folders = Model_plan::getFolders($dbconnection, $folders);
foreach($folders as $fold)
{
    if(!empty($folderid))
    {
        if($fold['parent'] == $folderid)
        {
            $element[] = array('id'=>$fold['id'], 'name'=>$fold['name'], 'url'=>$controller->pluginURL . $controller::FOLDERS_CONTROLLER . '?id=' . $fold['id'], 'type'=>'folder');
        }
    }
    else
    {
        if(empty($fold['parent']))
        {
            $element[] = array('id'=>$fold['id'], 'name'=>$fold['name'], 'url'=>$controller->pluginURL . $controller::FOLDERS_CONTROLLER . '?id=' . $fold['id'], 'type'=>'folder');
        }
        else
        {
            break;
        }
    }
}
$element = array_merge($element, $planinfolder);
$smarty->assign('folder_element', $element);
$smarty->assign('clean_uri', $cleanURI); // si clean_uri = 'true', on supprime (en JS) de l'uri tout ce qui n'est pas un id= et on remplace l'historique. Cela permet d'empecher les renvoi de formulaire au reload de la page.

$typeControllerPath = $controller->pluginURL . $controller::FOLDERS_CONTROLLER;
$smarty->assign('typeControllerPath', $typeControllerPath);

$smarty->display($controller->templatePath . 'plan_folder.html');
?>
