<?php
//Fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . '/common.php';
// include_once $path . '/Model_adm.php';
include_once $path . '/plugin/plan/Model_plan.php';
include_once $path . '/plugin/plan/Controller_plan.php';

$controller = new Controller_Plan($path, $dbconnection, $user);

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_PLAN');
$plugin_url = $arr[0]['apache_path'];

$page_url = "$plugin_url/".$arr[0]['index_page'];
$template_path= $path.$plugin_url.'templates/';

$path_data_plan = $path.'/data/plan/plans/';
$path_data_icons = $path.'/data/plan/icons/';


if(!$controller->isUserPerms['admin'])
{
	$smarty->display('no_access.html');
	exit(0);
}

$plan = null;
$foldersParentsTree = null;
if(!empty($_GET['id']) && is_numeric($_GET['id']))
{
	$planId = intval($_GET['id']);
	$plan = Model_plan::getPlan($dbconnection, $planId)[$planId];
}
// NAVBAR
$foldersParentsTree = Model_plan::getFolders($dbconnection, $plan['folders']);
$controller->setNavBar($navbar, $lang['WEBP_PLAN'], $foldersParentsTree, null, $plan);

$error_messages = array();

if(isset($_GET['action']) && !empty($_GET['action']))
{
	$action = $_GET['action'];

	if($action == 'upl1logo')
	{
		$name = str_replace(' ', '_', $_POST['new_name']); // Remplacer les espaces dans les nom de fichier par des underscores
		$group = $_POST['icon_group_select'];

		uploadNewIcon($dbconnection,$_FILES['logofile'],$name,$group,'ok',$path);
		$ext = pathinfo($_FILES['logofile']['name'],PATHINFO_EXTENSION);
		try{
			Model_Plan::addIcon($dbconnection,$name,"/data/plan/icons/",$ext,$group);
		}catch(Exception $e)
		{
			$error_messages[] = "Error addIcon : ".$e;
		}

		if(!empty($error_messages)) $smarty->assign('error_messages',$error_messages);
		else $smarty->assign('success_message',$lang['PLAN_UPL_ONE_ICON_SUCCESS']);
		$action='main';
	}
	elseif($action == 'upl4logos')
	{
		$name = str_replace(' ', '_', $_POST['new_name']);
		$group = $_POST['icon_group_select2'];

		$ext = pathinfo($_FILES['logo_ok']['name'],PATHINFO_EXTENSION);
		$ext2 = pathinfo($_FILES['logo_warning']['name'],PATHINFO_EXTENSION);
		$ext3 = pathinfo($_FILES['logo_critical']['name'],PATHINFO_EXTENSION);
		$ext4 = pathinfo($_FILES['logo_unknown']['name'],PATHINFO_EXTENSION);

		//Les extensions des 4 fichiers doivent être les mêmes
		if($ext == $ext2 && $ext2==$ext3 && $ext3 == $ext4)
		{
			uploadNewIcon($dbconnection,$_FILES['logo_ok'],$name,$group,'ok',$path);
			uploadNewIcon($dbconnection,$_FILES['logo_warning'],$name,$group,'warning',$path);
			uploadNewIcon($dbconnection,$_FILES['logo_critical'],$name,$group,'critical',$path);
			uploadNewIcon($dbconnection,$_FILES['logo_unknown'],$name,$group,'unknown',$path);

			try{
				Model_Plan::addIcon($dbconnection,$name,"/data/plan/icons/",$ext,$group);
			}catch(Exception $e)
			{
				$error_messages[] = "Error addIcon : ".$e;
			}
		}
		else $error_messages[] = $lang['PLAN_SAME_EXTENSION'];

		if(!empty($error_messages)) $smarty->assign('error_messages',$error_messages);
		else $smarty->assign('success_message',$lang['PLAN_UPL_FOUR_ICONS_SUCCESS']);

		$action='main';
	}
	elseif($action=='createGroup')
	{
		if(isset($_POST['name']) && !empty($_POST['name']))
		{
			try{
				Model_Plan::addIconGroup($dbconnection,$_POST['name']);
			}catch(Exception $e)
			{
				$error_messages[] = "Error addIconGroup : ".$e;
			}
			if(!empty($error_messages)) $smarty->assign('error_messages',$error_messages);
			else $smarty->assign('success_message',$lang['PLAN_ADD_GROUP_SUCESS']);
		}
		$smarty->assign('action',$action);
	}

	elseif($action=='updGroup')
	{
		if(isset($_POST['name']) && !empty($_POST['name']))
		{
			if(isset($_GET['id']) && !empty($_GET['id']))
			{
				$id = $_GET['id'];
				try{
					$group = Model_Plan::updateIconGroup($dbconnection,$id,$_POST['name']);
				}catch(Exception $e)
				{
					$error_messages[] = "Error updateIconGroup : ".$e;
				}
			}

			if(!empty($error_messages)) $smarty->assign('error_messages',$error_messages);
			else $smarty->assign('success_message',$lang['PLAN_UPD_GROUP_SUCESS']);
		}

		if(isset($_GET['id']) && !empty($_GET['id']))
		{
			$id = $_GET['id'];
			try{
				$group = Model_Plan::getIconGroup($dbconnection,$id)[0];
			}catch(Exception $e)
			{
				$error_messages[] = "Error getIconGroup : ".$e;
			}

			$smarty->assign('group',$group);
		}
		$smarty->assign('action',$action);
	}
	elseif($action=='delGroup')
	{
		if(isset($_GET['id']) && !empty($_GET['id']))
		{
			try{
				Model_Plan::deleteIconGroup($dbconnection,$_GET['id']);
			}catch(Exception $e)
			{
				$error_messages[] = "Error deleteIconGroup : ".$e;
			}
		}
		exit(0);
	}
	elseif ($action =="delIconInfo")
	{
		$id=$_GET['id'];

		$icon = Model_Plan::getObjectbyIcon($dbconnection,$id);
		$plan_names = array ();
		if(isset($icon) && !empty($icon))
		{
			$plan_names = array ();
			foreach ($icon as $obj_icn)
			{
				$plan = Model_plan::getPlan($dbconnection,$obj_icn['plan_id']);
				$plan_names[]=$plan[$obj_icn['plan_id']]['name'];
			}
		}
		echo json_encode($plan_names);
		exit(0);
	}
	elseif ($action =="delIcon")
	{
		$id=$_GET['id'];

		$icon = Model_Plan::getIcon($dbconnection,$id)[0];
		if(isset($icon) && !empty($icon))
		{
			try
			{
				$returDelIcon=unlink($path.$icon['path'].$icon['name']."_ok.".$icon['type']);
				if(file_exists($path.$icon['path'].$icon['name']."_warning.".$icon['type']))
				{
					unlink($path.$icon['path'].$icon['name']."_warning.".$icon['type']);
					unlink($path.$icon['path'].$icon['name']."_critical.".$icon['type']);
					unlink($path.$icon['path'].$icon['name']."_unknown.".$icon['type']);
				}
				if($returDelIcon==true) Model_Plan::deleteIcon($dbconnection,$id);
				else throw new Exception('File img miniature not writable');
			}
			catch (EsiaDbException $e)
			{
				$smarty->assign('l_error',$e->getMessage());
			}
			catch (Exception $e)
			{
				$smarty->assign('l_error',$e->getMessage());
			}
		}
		exit(0);
	}
	elseif($action=='updIcon')
	{
		if(isset($_POST['group']) && !empty($_POST['group']))
		{
			$group = $_POST['group'];
			if(isset($_GET['id']) && !empty($_GET['id']))
			{
				$id = $_GET['id'];
				try{
					$icon = Model_Plan::getIcon($dbconnection,$id)[0];
					$icon = Model_Plan::updateIcon($dbconnection,$id,$icon['name'],$icon['path'],$icon['type'],$group);
				}catch(Exception $e)
				{
					$error_messages[] = "Error updateIcon : ".$e;
				}
			}

			if(!empty($error_messages)) $smarty->assign('error_messages',$error_messages);
			else $smarty->assign('success_message',$lang['PLAN_UPD_ICON_SUCESS']);
		}

		if(isset($_GET['id']) && !empty($_GET['id']))
		{
			$id = $_GET['id'];
			try{
				$icon = Model_Plan::getIcon($dbconnection,$id)[0];
				$groups = Model_Plan::getIconGroup($dbconnection);
			}catch(Exception $e)
			{
				$error_messages[] = "Error getIconGroup : ".$e;
			}

			//echo "<pre>";print_r($groups); echo "</pre>";
			$smarty->assign('icon',$icon);
			$smarty->assign('groups',$groups);
		}

		$smarty->assign('action',$action);
	}

	if($action == 'main')
	{
		$icons = Model_plan::getIconByGroups($dbconnection);
		$groups = Model_plan::getIconGroup($dbconnection);
		$smarty->assign('groups',$groups);
		$smarty->assign('icons',$icons);
		$smarty->assign('action',$action);
	}

}
else
{
	$smarty->assign('action','main');
}

$smarty->display($template_path.'icon_admin.html');

function uploadNewIcon($dbconnection,$icon,$name,$group,$status,$path)
{
	$path_data_icons = $path.'/data/plan/icons/';

	if($icon['name']!=null) // Si un nouvel icone
	{
		//test si il n'y a pas d'erreur
		if ($icon['error'])
		{
			switch ($icon['error'])
			{
				case 1: // UPLOAD_ERR_INI_SIZE
					throw new Exception('file exceeds the maximum size by server (php.ini)'); break;
				case 2: // UPLOAD_ERR_FORM_SIZE
					throw new Exception('file exceeds the maximum size by HTML form'); break;
				case 3: // UPLOAD_ERR_PARTIAL
					throw new Exception('File transfer was interrupted'); break;
				case 4: // UPLOAD_ERR_NO_FILE
					throw new Exception('the size of file was null'); break;
				default:  throw new Exception('Unknown error');
			}
		}

		$upload_icons = $path_data_icons.$icon['name'];

		preg_match("/(\w+).(\w*)$/", $upload_icons, $match);
		if(is_array($match))
		{
			$file_ext=$match[2];
		}

		$name_icon = $name;

		$upload_icons = $path_data_icons.$name_icon.'_'.$status.'.'.$file_ext;

		if(!file_exists($upload_icons)) // Si il n'existe pas déjà
		{
			if($file_ext == 'svg') // Si fichier svg, pas de création de thumbnail
			{
				move_uploaded_file($icon['tmp_name'],$upload_icons);
			}
			elseif(move_uploaded_file($icon['tmp_name'],$upload_icons)==true) // Si le dwl s'est bien passé
			{
				//thumbnail creation
				list($width,$height) = getimagesize($upload_icons);

				$ratio = $width/$height;

				$NouvelleHauteur=$height;
				$NouvelleLargeur=$width;
				/*
				if($ratio > 1)
				{
					$NouvelleHauteur = 50/$ratio;
					$NouvelleLargeur = 50;
				}
				else
				{
					$NouvelleLargeur = 50*$ratio;
					$NouvelleHauteur = 50;
				}*/

				$thumb_create = imagecreatetruecolor($NouvelleLargeur,$NouvelleHauteur);
				$white = imagecolorallocate($thumb_create, 255, 255, 255);
				imagefill($thumb_create, 0, 0, $white);

				switch($file_ext)
				{
					case 'jpg':
						$source = imagecreatefromjpeg($upload_icons);
						break;
					case 'jpeg':
						$source = imagecreatefromjpeg($upload_icons);
						break;
					case 'png':
						$source = imagecreatefrompng($upload_icons);
						break;
					case 'gif':
						$source = imagecreatefromgif($upload_icons);
						break;
					case 'bmp':
						$source = imagecreatefrombmp($upload_icons);
						break;
					default:
						$source = imagecreatefromjpeg($upload_icons);
				}

				imagecopyresampled($thumb_create , $source, 0, 0, 0, 0, $NouvelleLargeur, $NouvelleHauteur, $width,$height);
				$size = min(imagesx($thumb_create), imagesy($thumb_create));

				switch($file_ext)
				{
					case 'jpg' || 'jpeg':
						imagejpeg($thumb_create,$upload_icons);
						break;
					case 'png':
						imagepng($thumb_create,$upload_icons);
						break;
					case 'gif':
						imagegif($thumb_create,$upload_icons);
						break;
					default:
						imagejpeg($thumb_create,$upload_icons);
						break;
				}
			}
			else
			{
				throw new Exception('File not download (icons)');
			}
		}
		else
		{
			throw new Exception('File error name.');
		}
	}
}

?>
