<?php
//Fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . 'common.php';
include_once $path . '/plugin/plan/Model_plan.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_PLAN');
$plugin_url = $arr[0]['apache_path'];

$page_url = "$plugin_url/".$arr[0]['index_page'];
$template_path= $path.$plugin_url.'templates/';

//NAVBAR
$navbar->addElement($lang[$arr[0]['name']],$page_url,$arr[0]['icon']);

$errors = array();
if(isset($_GET['action']))
{
	$action = $_GET['action'];
	$smarty->assign('action',$action);

	if($action == 'getLinkObjects')
	{
		$plan = $_GET['plan'];
		$links = Model_plan::getObjectsByPlan($dbconnection,$plan,1); //1 = type link dans DB
		foreach($links as $key=>$link)
		{
			$links[$key]['params'] =json_decode($link['params'],true);

			$services = explode(",",$links[$key]['params']['service']);
			if(!empty($services[0]))
			{
				foreach($services as $k => $srvc)
				{
					$service = Model_esia::getServices($dbconnection,null,$srvc)[0];

					$links[$key]['service'][$k]['name'] = Model_esia::getCommonName($lang,$service['name'],$service['check_plugin_name']);
					$links[$key]['service'][$k]['name_tech']=$service['check_plugin_name'];
					$links[$key]['service'][$k]['state'] = $service['real_state'];

					if(preg_match("/SNMP_SW_INTERFACE_EASY/",$service['check_plugin_name']) && $service['real_state'] != 3)
					{
						preg_match("/speed:\s(\S+)\s(\S+)/",$service['stdout'],$matches);
						$speed = intval($matches[1]);
						$speed = $speed *1024*1024;
						$unit  = $matches[2];

						$service['value']['in']=intval($service['value']['in']);
						$service['value']['out']=intval($service['value']['out']);
						$percent_in = floor(($service['value']['in']/$speed)*100);
						$percent_out = floor(($service['value']['out']/$speed)*100);

						$links[$key]['service'][$k]['out']['color'] = setColor($percent_out);
						$links[$key]['service'][$k]['in']['color'] = setColor($percent_in);
					}
					else
					{
						$links[$key]['service'][$k]['out']['color'] = "#83bc00";
						$links[$key]['service'][$k]['value'] = "OK";
						if($service['real_state'] == 2)
						{
							$links[$key]['service'][$k]['value'] = $lang['LGD_CRI'];
							$links[$key]['service'][$k]['out']['color'] = "#da002e";
						}
						elseif($service['real_state'] == 1)
						{
							$links[$key]['service'][$k]['value'] = $lang['LGD_WARN'];
							$links[$key]['service'][$k]['out']['color'] = "#ffcb1f";
						}
						elseif($service['real_state'] == 3)
						{
							$links[$key]['service'][$k]['value'] = $lang['LGD_UNKNOWN'];
							$links[$key]['service'][$k]['out']['color'] = "#575759";
						}
						elseif($service['real_state'] == 4)
						{
							$links[$key]['service'][$k]['value'] = $lang['LGD_MAINTENANCE'];
							$links[$key]['service'][$k]['out']['color'] = "#575759";
						}
						$links[$key]['service'][$k]['in']['color']=$links[$key]['service'][$k]['out']['color'];
					}
					$links[$key]['service'][$k]['value'] = $service['value'];
				}
			}
		}
		echo json_encode($links);
		exit(0);
	}
	elseif($action == 'setLinkOnPlan')
	{
		$plan = $_GET['plan'];
		$src = $_GET['src'];
		$tar = $_GET['tar'];

		$params['source']=$src;
		$params['target']=$tar;
		$params['service']="";

		$params = json_encode($params);

		$connector = model_plan::addObjectPlan($dbconnection,$plan,$src."-".$tar,1,null,$params,null);
		if($connector) echo json_encode($connector);
		else echo json_encode(null);
		exit(0);
	}
	elseif($action == 'updElemLink')
	{
		$object = $_GET['id'];
		$obj = Model_plan::getObject($dbconnection,$_GET['id']); //1 = type link dans DB
		$obj['params'] =json_decode($obj['params'],true);

		$services="";
		if((isset($_POST['element']) && !empty($_POST['element'])) || isset($_POST['nbLink']))
		{
			if(isset($_POST['element']) && !empty($_POST['element']))
			{
				foreach($_POST['element'] as $elem)
				{
					if(!empty($elem['id'])) $services .= $elem['id'].',';
				}
				//Enlever la virgule à la fin si présente
				if(substr($services, -1) == ',') $services = substr($services, 0, -1);

				if(!empty($services))
				{
					if(isset($obj['params']['service']))
					{
						if(empty($obj['params']['service']))
						{
							$obj['params']['service'] = $services;
						}
						else
						{
							$obj['params']['service'] .= ",".$services;
						}
					}
					else
					{
						$obj['params']['service'] = $services;
					}
				}
			}

			if(isset($_POST['svcByLink']) && $_POST['svcByLink'] == 'on') $obj['params']['number'] = $_POST['nbLink'];
			else $obj['params']['number'] = '1';

			$params = json_encode($obj['params']);

			try{
				$idUpd = Model_plan::updateObject($dbconnection,$_GET['id'],$obj['plan_id'],$obj['name'],$obj['type'],$obj['icon_id'],$params,$obj['link']);
			}catch(Exception $e)
			{
				$errors[] = "ERROR update : " . $e;
			}
		}

		if (isset($errors) && !empty($errors))
		{
			$smarty->assign('error_messages',$errors);
		}
		else
		{
			$smarty->assign('success_message',$lang['PLAN_UPDATE_LINK']);
		}

		$action='confLink';
		$smarty->assign('action',$action);
	}
	elseif($action =="getservice")
	{
		if(isset($_GET['nodeid'])&& is_numeric($_GET['nodeid']))
		{
			$node = Model_esia::InstanceNode($dbconnection, $_GET['nodeid']);
			if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());
				$list=array();
				foreach ($services as $service)
				{
					$common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);
					$list[$service['id']]=$common_name;
				}
				echo json_encode($list,true);
				exit(0);
			}
		}
	}
	elseif ($action=='returnSenseLink')
	{
		$id_link = $_GET['id'];

		$link = Model_plan::getObject($dbconnection,$id_link);
		$link['params'] = json_decode($link['params'],true);

		$services = explode(",",$link['params']['service']);

		$link['params']['service'] = array_reverse($services);
		$link['params']['service'] = implode(",",$link['params']['service']);
		$params = json_encode($link['params']);

		try{
			$idUpd = Model_plan::updateObject($dbconnection,$id_link,$link['plan_id'],$link['name'],$link['type'],$link['icon_id'],$params,$link['link']);
		}catch(Exception $e)
		{
			$errors[] = "ERROR delete service : " . $e;
		}
		$action='confLink';
		$smarty->assign('action',$action);

	}
	elseif ($action=='reverseLink')
	{
		$id_link = $_GET['id'];

		$link = Model_plan::getObject($dbconnection,$id_link);
		$link['params'] = json_decode($link['params'],true);

		$oldSource = $link['params']['source'];
		$oldTarget = $link['params']['target'];
		$link['params']['source'] = $oldTarget;
		$link['params']['target'] = $oldSource;
		$params = json_encode($link['params']);

		try{
			$idUpd = Model_plan::updateObject($dbconnection,$id_link,$link['plan_id'],$link['name'],$link['type'],$link['icon_id'],$params,$link['link']);
		}catch(Exception $e)
		{
			$errors[] = "ERROR update : " . $e;
		}
		$action='confLink';
		$smarty->assign('action',$action);

	}
	elseif($action=='delElemLink')
	{
		$id = $_GET['id'];
		$service = $_GET['service'];

		$object = Model_plan::getObject($dbconnection,$id);
		$smarty->assign('object',$object);
		$object['params'] = json_decode($object['params'],true);

		$services = explode(",",$object['params']['service']);

		$newServices = "";
		foreach($services as $key=>$svc)
		{
			if($svc != $service)
			{
				$newServices .= $svc.",";
			}
		}

		if(substr($newServices, -1) == ',') $newServices = substr($newServices, 0, -1);
		$object['params']['service'] = $newServices;


		$params = json_encode($object['params']);

		try{
			$idUpd = Model_plan::updateObject($dbconnection,$id,$object['plan_id'],$object['name'],$object['type'],$object['icon_id'],$params,$object['link']);
		}catch(Exception $e)
		{
			$errors[] = "ERROR delete service : " . $e;
		}

		if(isset($errors) && !empty($errors)) $smarty->assign('error_messages',$errors);
		elseif(!empty($service)) $smarty->assign('success_message',$lang['PLAN_DELETE_SERVICE_LINK']);
		$action='confLink';
		$smarty->assign('action',$action);
	}

	if($action == 'confLink')
	{
		$src = $_GET['src'];
		$tar = $_GET['tar'];
		$id = $_GET['id'];

		$link = Model_plan::getObject($dbconnection,$id);
		$src = Model_plan::getObject($dbconnection,$src);
		$tar = Model_plan::getObject($dbconnection,$tar);

		$link['params'] = json_decode($link['params'],true);

		$services = explode(",",$link['params']['service']);
		if(!empty($services[0]))
		{
			foreach($services as $k => $srvc)
			{
				$service = Model_esia::getServices($dbconnection,null,$srvc)[0];
				$link['service'][$k]['name'] = Model_esia::getCommonName($lang,$service['name'],$service['check_plugin_name']);
				$link['service'][$k]['node'] = $service['device_name'];
				$link['service'][$k]['id'] = $service['id'];
				$page_control='/node_view.php?name=';
				$page = Model_esia::getPageControl($dbconnection,$service['device_type']);
				if(!empty($page))
				{
					$page_control = Model_esia::replacePageControlVariable($page, $service['device_id']);
				}
				$link['service'][$k]['page'] = $page_control.$service['device_id'];
			}
		}

		//Récupération des noeuds
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_ASSOC);
		$list = array();
		foreach($nodes as $node)
		{
			$list[] = array('id'=>$node['id'],'name'=> $node['name']);
		}
		$smarty->assign('adm_list_node', $list);

		$smarty->assign('link',$link);
		$smarty->assign('src',$src);
		$smarty->assign('tar',$tar);
		$smarty->display($template_path.'plan_image.html');
	}
}


function setColor($percent)
{
	$val = "#AB0A00";

	$percent = intval($percent);

	if($percent <= 10)
	{
		$val = "#3d73ff";
	}
	elseif($percent <= 20)
	{
		$val = "#0093CF";
	}
	elseif($percent <= 30)
	{
		$val = "#66B131";
	}
	elseif($percent <= 40)
	{
		$val = "#D5FE00";
	}
	elseif($percent <= 50)
	{
		$val = "#FFFF32";
	}
	elseif($percent <= 60)
	{
		$val = "#FFDD00";
	}
	elseif($percent <= 70)
	{
		$val = "#FE9900";
	}
	elseif($percent <= 80)
	{
		$val = "#FE5900";
	}
	elseif($percent <= 90)
	{
		$val = "#FE0000";
	}
	else
	{
		$val = "#AB0A00";
	}
	return $val;
}

?>
